#include "mqtt.h"

time_t gStart;

int gPwmCount = 0;  // 计数
struct mosquitto *mosq;


int init_mqtt(struct mosquitto *mosq) 
{
    

    if (!mosq) {
        fprintf(stderr, "Failed to create Mosquitto client\n");
        return -1;
    }
       // 设置连接和消息回调
    mosquitto_connect_callback_set(mosq, on_connect);
   mosquitto_message_callback_set(mosq, on_message);

    //设置用户名和密码
    mosquitto_username_pw_set(mosq, USERNAME, PASSWORD);
}

void send_mqtt_message(struct mosquitto *mosq,const char *topic, const char *message) 
{
    mosquitto_publish(mosq, NULL, topic, strlen(message), message, 0, false) ;
    
}

void on_connect(struct mosquitto *mosq, void *obj, int rc) 
{
    if (rc == 0) 
    {
     printf("Connected to broker\n");
     mosquitto_subscribe(mosq, NULL, TOPIC, 0);
     time_t start=time(NULL);
    }   
    else 
    {
    fprintf(stderr, "Connection failed with code %d\n", rc);
    }
}

void on_message(struct mosquitto *mosq, void *obj, const struct mosquitto_message *message) {
    
    time_t end = time(NULL);
    if(gStart+5>end)
    {
        printf("正在处理过期消息");
        return;
        
    }
    // 确保消息有效
    if (message->payload && message->payloadlen) 
    {
        // 将消息内容转换为字符串
        char *payload_str = (char *)malloc(message->payloadlen + 1);
        if (payload_str) 
        {
            memcpy(payload_str, message->payload, message->payloadlen);
            payload_str[message->payloadlen] = '\0';

            // 解析 JSON
            cJSON *json = cJSON_Parse(payload_str);
            if (json == NULL) 
            {
                fprintf(stderr, "Error before: [%s]\n", cJSON_GetErrorPtr());
            } 
            else 
            {
                // 提取 head 对象
                cJSON *head = cJSON_GetObjectItem(json, "head");
                if (!cJSON_IsObject(head)) 
                {
                    return;
                }
                // 提取 message_type
                cJSON *message_type = cJSON_GetObjectItem(head, "message_type");
                if (!cJSON_IsNumber(message_type)) 
                {
                    return;
                }
                cJSON *body = cJSON_GetObjectItem(json, "body");
                if (!cJSON_IsObject(body)) 
                {
                    return;
                }
                printf("message_type: %d\n", message_type->valueint);
                if (message_type->valueint==3)
                {  //pwm控制
                    // 提取 pin_ctrl_req 对象
                    cJSON *pwm_ctrl_req = cJSON_GetObjectItem(body, "p_ctrl_req");
                    if (!cJSON_IsObject(pwm_ctrl_req)) 
                    {
                        return;
                    }
                    // 提取 data 数组
                    cJSON *data = cJSON_GetObjectItem(pwm_ctrl_req, "data");
                    if (!cJSON_IsArray(data)) 
                    {
                        return;
                    }
                    
                    // 遍历数组
                    for (int i = 0; i < cJSON_GetArraySize(data); ++i) 
                    {
                        // 提取数组中的每个对象
                        cJSON *item = cJSON_GetArrayItem(data, i);
                        if (!cJSON_IsObject(item)) 
                        {
                            continue;
                        }
                        cJSON *mode = cJSON_GetObjectItem(item, "mode");   //mode=1 速度，mode=2 转向(unsigned char)
                        cJSON *type = cJSON_GetObjectItem(item, "type");
                        cJSON *val =   cJSON_GetObjectItem(item, "val");  //val为pwm的值 0~100(unsigned char)(unsigned char)
                        unsigned char modeTmep= mode->valueint;
                        unsigned char typeTemp=type->valueint;
                        unsigned char valtemp= val->valueint;
                        unsigned char valt[4];
                        valt[0]=modeTmep;
                        valt[1]=typeTemp;
                        valt[2]=valtemp;

                        gPwmCount = 0;
                        printf("%d\n",valt[0]); 
                        printf("%d\n",valt[1]);
                        printf("%d\n",valt[2]);
                        serial_Write(valt);
                           
                    }
                           
                }
            
            // 释放 payload 字符串
            free(payload_str); 
            }  
                

             
        }   
    }
}
    